#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
typedef vector<int> vi;
typedef vector<ll> vll;
 
typedef vector<vi> vvi;
typedef vector<vll> vvll;
 
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
 
typedef vector<pii> vpii;
typedef vector<pll> vpll;
 
typedef vector<vpii> vvpii;
typedef vector<vpll> vvpll;
 
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define fi first
#define se second
 
template<class T> bool ckmin(T &a, const T &b) {return a > b ? a = b, 1 : 0;}
template<class T> bool ckmax(T &a, const T &b) {return a < b ? a = b, 1 : 0;}
 
namespace debug {
    void __print(int x) {cerr << x;}
    void __print(long long x) {cerr << x;}
    void __print(double x) {cerr << x;}
    void __print(long double x) {cerr << x;}
    void __print(char x) {cerr << '\'' << x << '\'';}
    void __print(const string &x) {cerr << '\"' << x << '\"';}
    void __print(const char *x) {cerr << '\"' << x << '\"';}
    void __print(bool x) {cerr << (x ? "true" : "false");}
 
    template<typename T, typename V>
    void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
    template<typename T>
    void __print(const T &x) {int f = 0; cerr << '{'; for(auto z : x) cerr << (f++ ? "," : ""), __print(z); cerr << "}";}
    void _print() {cerr << "]\n";}
    template <typename T, typename... V>
    void _print(T t, V... v) {__print(t); if(sizeof...(v)) cerr << ", "; _print(v...);}
 
#ifdef ljuba
#define dbg(x...) cerr << "\e[91m" << "LINE(" << __LINE__ << ") -> " << "[" << #x << "] = ["; _print(x)
#else
#define dbg(x...)
#endif
}
 
using namespace debug;
 
const char nl = '\n';
 
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
 
/*
???????? ?????? ???????, ??? ???? ??? ????????????? (????? ???? ???????? ?????) 
?????? ?? ????????? ???? ????? ????????? ?? ??????, ????????? ??????? ? ???????
*/

const int mxN = 1e4 + 12;
int ans[mxN][4];

void solve() {
    int n;
    cin >> n;
    int o, a, b, ab;
    cin >> o >> a >> b >> ab;
    vector<pair<string, int>> v(n);

    //jako ruzan kod :(

    for(auto &z : v) {
        cin >> z.fi >> z.se;
    }

    for(int i = 0; i < n; ++i) {
        if(v[i].fi == "O") {
            //uzmi O
            int uzmi = min(v[i].se, o);
            v[i].se -= uzmi;
            o -= uzmi;
            ans[i][0] += uzmi;
        }
    }

    for(int i = 0; i < n; ++i) {
        if(v[i].fi == "A") {
            //uzmi A
            int uzmi = min(v[i].se, a);
            v[i].se -= uzmi;
            a -= uzmi;
            ans[i][1] += uzmi;
        }
    }

    for(int i = 0; i < n; ++i) {
        if(v[i].fi == "B") {
            //uzmi B
            int uzmi = min(v[i].se, b);
            v[i].se -= uzmi;
            b -= uzmi;
            ans[i][2] += uzmi;
        }
    }

    for(int i = 0; i < n; ++i) {
        if(v[i].fi == "A" || v[i].fi == "B") {
            //uzmi O
            int uzmi = min(v[i].se, o);
            v[i].se -= uzmi;
            o -= uzmi;
            ans[i][0] += uzmi;
        }
    }

    for(int i = 0; i < n; ++i) {
        if(v[i].fi == "AB") {
            int uzmi = min(v[i].se, o);
            v[i].se -= uzmi;
            o -= uzmi;
            ans[i][0] += uzmi;

            uzmi = min(v[i].se, a);
            v[i].se -= uzmi;
            a -= uzmi;
            ans[i][1] += uzmi;

            uzmi = min(v[i].se, b);
            v[i].se -= uzmi;
            b -= uzmi;
            ans[i][2] += uzmi;

            uzmi = min(v[i].se, ab);
            v[i].se -= uzmi;
            ab -= uzmi;
            ans[i][3] += uzmi;
        }
    }

    for(int i = 0; i < n; ++i) {
        if(v[i].se != 0) {
            cout << "nemoguce" << nl;
            return;
        }
    }

    cout << "moguce" << nl;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < 4; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << nl;
    }
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    int testCases = 1;
    //cin >> testCases;
    while(testCases--)
        solve();
}